git: 0d60235ecd6c - main - stress2: Add another "mdconfig -d -o force" test scenario

Peter Holm pho at FreeBSD.org
Sun Jul 25 07:01:36 UTC 2021


The branch main has been updated by pho:

URL: https://cgit.FreeBSD.org/src/commit/?id=0d60235ecd6c711b997345c28e15f0335811e19f

commit 0d60235ecd6c711b997345c28e15f0335811e19f
Author:     Peter Holm <pho at FreeBSD.org>
AuthorDate: 2021-07-25 07:00:53 +0000
Commit:     Peter Holm <pho at FreeBSD.org>
CommitDate: 2021-07-25 07:00:53 +0000

    stress2: Add another "mdconfig -d -o force" test scenario
---
 tools/test/stress2/misc/force8.sh | 81 +++++++++++++++++++++++++++++++++++++++
 1 file changed, 81 insertions(+)

diff --git a/tools/test/stress2/misc/force8.sh b/tools/test/stress2/misc/force8.sh
new file mode 100755
index 000000000000..77a8e6fd97bf
--- /dev/null
+++ b/tools/test/stress2/misc/force8.sh
@@ -0,0 +1,81 @@
+#!/bin/sh
+
+#
+# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
+#
+# Copyright (c) 2021 Peter Holm
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+# "mdconfig -o force" test scenario with nullfs.
+# Variation of force4.sh
+
+# Seen with WiP kernel code:
+# panic: refcount 0xfffffe015105bdfc wraparound
+# https://people.freebsd.org/~pho/stress/log/log0154.txt
+
+. ../default.cfg
+
+mount | grep $mntpoint | grep -q /dev/md && umount -f $mntpoint
+mdconfig -l | grep -q md$mdstart &&  mdconfig -d -u $mdstart
+mdconfig -a -t swap -s 1g -u $mdstart
+flags=$newfs_flags
+[ `jot -r 1 0 1` -eq 1 ] && flags="-j"
+echo "newfs $flags md$mdstart"
+newfs $flags md$mdstart > /dev/null 2>&1
+mount /dev/md$mdstart $mntpoint
+chmod 777 $mntpoint
+
+mp2=${mntpoint}2
+mkdir -p $mp2
+mount -t nullfs $mntpoint $mp2 || exit 1
+
+export LOAD=80
+export MAXSWAPPCT=80
+export RUNDIR=$mp2/stressX
+export runRUNTIME=3m
+export TESTPROGS='
+testcases/rename/rename
+testcases/swap/swap
+testcases/dirnprename/dirnprename
+testcases/dirrename/dirrename
+'
+
+su $testuser -c 'cd ..; ./testcases/run/run $TESTPROGS' > /dev/null 2>&1 &
+
+sleep `jot -r 1 20 60`
+while mdconfig -l | grep -q md$mdstart; do
+	mdconfig -d -u $mdstart -o force || sleep 1
+done
+sleep 1
+../tools/killall.sh
+wait
+umount $mp2
+n=0
+while mount | grep $mntpoint | grep -q /dev/md; do
+	umount $mntpoint || sleep 1
+	[ $((n += 1)) -gt 300 ] && { echo FAIL; exit 1; }
+done
+exit 0


More information about the dev-commits-src-all mailing list